(* Afficheur 7 segments *)

let a A B C D = A || C || (B & D) || (not B && not D) ;;
let b A B C D = (not B) || (not C && not D) || (C && D) ;;
let c A B C D = (not C) || B || D ;;
let d A B C D = A || (not B && not D) || (C && not B) || (C && not D) ||(B && not C && D) ;;
let e A B C D = (C && not D) || (not B && not D) ;;
let f A B C D = A || (not C && not D) || (B && not C) || (B && not D) ;;
let g A B C D = A || (B && not C) || (C && not D) || (not B && C) ;;

let afficheur n = 
  let A = (n/8 mod 2=1) and B = (n/4 mod 2=1) 
  and C = (n/2 mod 2=1) and D = (n mod 2=1)
  in begin
      if (a A B C D) then print_string " _";
      print_newline();
      if (f A B C D) then print_char `|` else print_char ` `;
      if (g A B C D) then print_char `_` else print_char ` `;
      if (b A B C D) then print_char `|` else print_char ` `;
      print_newline();
      if (e A B C D) then print_char `|` else print_char ` `;
      if (d A B C D) then print_char `_` else print_char ` `;
      if (c A B C D) then print_char `|` else print_char ` `;
      print_newline();
    end;;

afficheur 0; afficheur 1; afficheur 2; afficheur 3; afficheur 4; 
afficheur 5; afficheur 6; afficheur 7; afficheur 8; afficheur 9;;
